<template>
  <section>
    <v-row justify="center" no-gutters>
      <v-card style="width: 100%">
        <v-toolbar style="position:relative" color="transparent" elevation="0">
          <v-spacer />
          <v-toolbar-title class="mt-5">
            <span class="primary--text">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-file-document</v-icon
              ><b>{{ manageTest == 'add' ? 'Nova prova' : 'Editar prova' }}</b>
            </span>
          </v-toolbar-title>
          <v-spacer />
          <v-tooltip color="red" bottom>
            <template v-slot:activator="{ on }">
              <v-icon
                v-on="on"
                style="position:absolute; right: 15px"
                color="red"
                @click="handleClose"
                >mdi-close</v-icon
              >
            </template>
            <span><b>Fechar</b> janela</span>
          </v-tooltip>
        </v-toolbar>
        <!-- toolbar -->
        <v-row class="mt-2" no-gutters justify="center">
          <v-btn :class="tab == 0 ? 'test' : ''" outlined elevation="0" small @click="goTab0">
            etapa 1
          </v-btn>
          <v-btn
            :disabled="manageTest == 'edit'"
            :class="tab == 1 ? 'test mx-2' : 'mx-2'"
            outlined
            elevation="0"
            small
            @click="goTab1"
          >
            etapa 2
          </v-btn>
        </v-row>
        <!-- CONTEUDO etapa1 -->
        <v-card-text class="px-12 pt-0 pb-0">
          <v-container>
            <v-row v-if="tab == 0">
              <v-col cols="12" class="py-2">
                <b style="font-size: 1.1rem" class="primary--text">Etapa 1 - Dados Gerais</b>
              </v-col>
              <v-col cols="12" align="center">
                <v-text-field
                  autofocus
                  v-model="title"
                  label="Título*"
                  required
                  prepend-icon="mdi-pencil-outline"
                ></v-text-field>
              </v-col>
              <v-col cols="12" align="center">
                <v-text-field
                  class="mt-n4"
                  v-model="instructions"
                  label="Instruções para prova*"
                  required
                  prepend-icon="mdi-chat-outline"
                ></v-text-field>
              </v-col>
              <v-col cols="12" align="center">
                <v-select
                  :disabled="manageTest == 'edit'"
                  prepend-icon="mdi-account-group-outline"
                  class="mt-n4"
                  v-model="selectedClasses"
                  :items="classes"
                  item-text="name"
                  item-value="id"
                  label="Classes*"
                  multiple
                  small-chips
                  hint="Selecione as classes que terão essa prova"
                  persistent-hint
                ></v-select>
              </v-col>
              <v-col cols="12" align="center">
                <v-select
                  :disabled="manageTest == 'edit'"
                  prepend-icon="mdi-eye-outline"
                  class="mt-n4"
                  v-model="selectedMonitor"
                  :items="monitors"
                  item-text="name"
                  item-value="id"
                  label="Monitor"
                  multiple
                  small-chips
                  hint="Selecione os monitores para essa prova"
                  persistent-hint
                ></v-select>
              </v-col>
              <v-col cols="12">
                <SelectData
                  :icon="'mdi-calendar-edit'"
                  :title="'Data Início Prova'"
                  :toUpdate="editInitialDate"
                  @selectedDateDone="updateTestInitialDate"
                />
              </v-col>
              <v-col cols="12" class="mt-n4">
                <SelectData
                  :icon="'mdi-calendar-edit'"
                  :title="'Data Fim Prova'"
                  :toUpdate="editEndDate"
                  @selectedDateDone="updateTestEndDate"
                />
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <!-- scrollform - etapa2 -->
        <div v-if="tab == 1" class="ml-3 mt-4 scrollForm">
          <v-row no-gutters>
            <v-col cols="12" class="py-2 px-12">
              <b style="font-size: 1.1rem" class="primary--text"
                >Etapa 2 - Selecionando as Perguntas</b
              >
            </v-col>
            <!-- TABELA ESQUERDA -->
            <v-col cols="12" sm="12" md="12" lg="6" xl="6" class="pa-4">
              <v-card class="pt-3 px-4">
                <v-row no-gutters>
                  <span class="primary--text">
                    <v-icon color="primary" class="mr-2">mdi-database </v-icon>
                    <b>Banco de perguntas ({{ questions.length }})</b>
                  </span>
                  <v-spacer />
                  <div
                    style="display:flex; align-items:center; justify-content:flex-end !important"
                  ></div>
                </v-row>
                <v-row no-gutters class="mt-3" align="center">
                  <v-col :cols="selectedFilter == 'byArea' ? '3' : '6'" align="end">
                    <span style="font-size: 0.9rem"><b>Filtrar por:</b></span>
                  </v-col>
                  <v-col cols="12" sm="3" md="3" lg="3" xl="3">
                    <v-select
                      class="mx-3 my-4"
                      dense
                      v-model="selectedFilter"
                      flat
                      hide-no-data
                      hide-details
                      item-text="name"
                      item-value="value"
                      :items="filterAutoComplete"
                    ></v-select>
                  </v-col>
                  <v-col v-if="selectedFilter == 'byArea'" cols="12" sm="3" md="3" lg="3" xl="3">
                    <!-- caso opte por busca por área -->
                    <v-select
                      class="mx-3 my-4"
                      dense
                      v-model="selectedArea"
                      label="Escolha a área"
                      flat
                      hide-no-data
                      hide-details
                      item-text="name"
                      item-value="id"
                      :items="filterAreas"
                    ></v-select>
                  </v-col>
                  <v-col cols="12" sm="3" md="3" lg="3" xl="3">
                    <div style="display:flex; align-items:center">
                      <v-text-field
                        v-model="inputSearch"
                        autofocus
                        class="pa-0 mx-3 my-4"
                        label="Pesquisar por..."
                        single-line
                        hide-details
                      />
                      <v-btn class="primary white--text" icon fab x-small @click="handleSearch()">
                        <v-icon>mdi-magnify</v-icon>
                      </v-btn>
                    </div>
                  </v-col>
                </v-row>
                <v-data-table
                  class="elevation-0 pb-3 mt-1"
                  calculate-widths
                  :search="search"
                  :headers="headers"
                  :items="questions"
                  :footer-props="{
                    itemsPerPageText: 'Questões por página',
                    itemsPerPageOptions: [10],
                    prevIcon: 'mdi-chevron-left-circle',
                    nextIcon: 'mdi-chevron-right-circle',
                  }"
                >
                  <!-- titulo -->
                  <template v-slot:[`item.title`]="{ item }">
                    <v-tooltip bottom color="primary">
                      <template v-slot:activator="{ on }">
                        <span
                          v-on="on"
                          class="viewQuestionStyle"
                          @click="handleViewQuestion(item)"
                          >{{ item.title }}</span
                        >
                      </template>
                      <span><b>Ver</b> Questão</span> </v-tooltip
                    ><v-icon
                      v-if="showQuestionAlreadySelected(item)"
                      color="green"
                      class="pl-2"
                      x-small
                      >mdi-check</v-icon
                    >
                  </template>
                  <!-- Área -->
                  <template v-slot:[`item.area`]="{ item }">
                    <div style="line-height: 1.1rem">
                      <span
                        style="font-size: 0.8rem; font-weight: 500;"
                        v-for="(areaId, index) in item.area"
                        :key="index"
                      >
                        {{ showNameOfArea(areaId) }}
                        <span v-if="index != item.area.length - 1"><br /></span>
                      </span>
                    </div>
                  </template>
                  <!-- dificuldade -->
                  <template v-slot:[`item.difficulty`]="{ item }">
                    {{ showDifficultyType(item.difficulty) }}
                  </template>
                  <!-- Tipo questão -->
                  <template v-slot:[`item.questionType`]="{ item }">
                    {{ showQuestionType(item.questionType) }}
                  </template>
                  <!-- Ações -->
                  <template v-slot:[`item.actions`]="{ item }">
                    <div class="ehqTable">
                      <v-tooltip bottom color="primary">
                        <template v-slot:activator="{ on }">
                          <v-icon v-on="on" small @click="handleViewQuestion(item)">mdi-eye</v-icon>
                        </template>
                        <span><b>Ver</b> questão</span>
                      </v-tooltip>
                      <v-tooltip bottom color="primary">
                        <template v-slot:activator="{ on }">
                          <v-icon v-on="on" small @click="addQuestion(item)"
                            >mdi-chevron-right</v-icon
                          >
                        </template>
                        <span><b>Adicionar</b> questão</span>
                      </v-tooltip>
                    </div>
                  </template>
                  <!-- footer -->
                  <template v-slot:[`footer.page-text`]="{ pageStart, pageStop, itemsLength }">
                    <div class="mt-1">
                      <span>
                        <b>Exibindo perguntas:</b> {{ pageStart }}-{{ pageStop }} de
                        <b>{{ itemsLength }} encontradas.</b>
                      </span>
                    </div>
                  </template>
                </v-data-table>
              </v-card>
            </v-col>
            <!-- TABELA DIREITA -->
            <v-col cols="12" sm="12" md="12" lg="6" xl="6" class="pa-4">
              <v-card class="pt-3 px-4">
                <v-row no-gutters>
                  <span class="primary--text">
                    <v-icon color="primary" class="mr-2">mdi-clipboard-text-outline </v-icon>
                    <b>Perguntas selecionadas para prova ({{ selectedQuestions.length }})</b>
                  </span>
                  <v-col
                    v-if="selectedQuestions.length == 0"
                    cols="12"
                    class="my-10"
                    align="center"
                    style="font-size:0.95rem"
                  >
                    Ops, parece que essa prova ainda não tem <b>nenhuma</b> pergunta selecionada :(
                  </v-col>
                </v-row>
                <v-data-table
                  v-if="selectedQuestions.length > 0"
                  class="elevation-0 pb-3 mt-1"
                  calculate-widths
                  :headers="selectedHeaders"
                  :items="selectedQuestions"
                  :footer-props="{
                    itemsPerPageText: 'Questões por página',
                    itemsPerPageOptions: [10],
                    prevIcon: 'mdi-chevron-left-circle',
                    nextIcon: 'mdi-chevron-right-circle',
                  }"
                >
                  <!-- header -->
                  <template v-slot:[`header.weight`]="{}">
                    <span> Valor prova ({{ selectedQuestionsTotalWeight }}/10) </span>
                    <v-icon v-if="selectedQuestionsTotalWeight !== 10" x-small color="red"
                      >mdi-close</v-icon
                    >
                    <v-icon v-else color="green" x-small>mdi-check</v-icon>
                  </template>
                  <!-- titulo -->
                  <template v-slot:[`item.title`]="{ item }">
                    <v-tooltip bottom color="primary">
                      <template v-slot:activator="{ on }">
                        <span
                          v-on="on"
                          class="viewQuestionStyle"
                          @click="handleViewQuestion(item)"
                          >{{ item.title }}</span
                        >
                      </template>
                      <span><b>Ver</b> Questão</span>
                    </v-tooltip>
                  </template>
                  <!-- dificuldade -->
                  <template v-slot:[`item.difficulty`]="{ item }">
                    {{ showDifficultyType(item.difficulty) }}
                  </template>
                  <!-- Tipo questão -->
                  <template v-slot:[`item.questionType`]="{ item }">
                    {{ showQuestionType(item.questionType) }}
                  </template>
                  <!-- Valor questão -->
                  <template v-slot:[`item.weight`]="{ item }">
                    <v-row justify="center">
                      <v-text-field
                        v-model="item.weight"
                        class="pa-0 ma-0"
                        style="max-width: 35px"
                        single-line
                        hide-details
                        @paste="$event.preventDefault()"
                        @click="validateMouse(item)"
                        @keypress="validate($event, item)"
                        @input="refreshWeightQuestions"
                      />
                    </v-row>
                  </template>
                  <!-- Ações -->
                  <template v-slot:[`item.actions`]="{ item }">
                    <div class="ehqTable">
                      <v-tooltip bottom color="primary">
                        <template v-slot:activator="{ on }">
                          <v-icon v-on="on" small @click="handleViewQuestion(item, 'menuRight')"
                            >mdi-eye</v-icon
                          >
                        </template>
                        <span><b>Ver</b> questão</span>
                      </v-tooltip>
                      <v-tooltip bottom color="primary">
                        <template v-slot:activator="{ on }">
                          <v-icon v-on="on" small @click="handleDeleteQuestion(item, 'menuRight')"
                            >mdi-delete</v-icon
                          >
                        </template>
                        <span><b>Excluir</b> questão</span>
                      </v-tooltip>
                    </div>
                  </template>
                  <template v-slot:[`footer.page-text`]="{ pageStart, pageStop }">
                    <div class="mt-1">
                      <span> <b>Exibindo perguntas:</b> {{ pageStart }}-{{ pageStop }} </span>
                    </div>
                  </template>
                </v-data-table>
                <v-row
                  v-if="selectedQuestions.length > 0 && selectedQuestionsTotalWeight !== 10"
                  class="py-2"
                  no-gutters
                  justify="center"
                  style="font-size:0.9rem"
                >
                  <span>
                    <v-icon class="pb-1 pr-2" small>mdi-alert</v-icon>
                    <b>Atenção</b> o somatório das questões deve valer um <b>total</b> de 10 pontos.
                  </span>
                </v-row>
              </v-card>
            </v-col>
          </v-row>
        </div>
        <!-- FOOTER DIALOG -->
        <v-card-actions class="mt-0 pb-6 pr-6">
          <v-spacer />
          <v-btn color="lighter" @click="handleClose" text>Fechar</v-btn>
          <v-btn
            :disabled="
              selectedQuestions.length == 0 || !title || selectedQuestionsTotalWeight !== 10
            "
            elevation="0"
            color="primary"
            class="px-4"
            @click="finish"
            >{{ manageTest == 'add' ? 'Adicionar Prova' : 'Editar Prova' }}</v-btn
          >
        </v-card-actions>
      </v-card>
      <!-- INICIO DOS DIALOGS -->
    </v-row>
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="deleteQuestion"
    />
    <v-dialog
      v-model="dialogViewQuestion"
      width="800px"
      @keydown.esc="closeDialogViewQuestion"
      @click:outside="closeDialogViewQuestion"
    >
      <ReadQuestion :areas="areas" :question="itemToView" @handleClose="closeDialogViewQuestion" />
    </v-dialog>
  </section>
</template>

<script>
import Teacher from '../../../servicesEhq/req/teacher'
import ReadQuestion from '../questionBank/ReadQuestion.vue'
import SelectData from '../../SelectData.vue'

export default {
  name: 'ManageTests',
  components: { ReadQuestion, SelectData },
  computed: {
    cleanAdvancedCollaborativeWork() {
      return this.$store.state.user.cleanAdvancedCollaborativeWork
    },
  },
  props: {
    manageTest: { type: String, default: 'add' },
    itemToEdit: { type: Object, default: () => {} },
  },
  data: () => ({
    headers: [
      { text: 'Título', align: 'center', sortable: false, value: 'title', width: '23%' },
      { text: 'Área', align: 'center', sortable: false, value: 'area', width: '22%' },
      { text: 'Dificuldade', align: 'center', sortable: false, value: 'difficulty', width: '20%' },
      { text: 'Tipo', align: 'center', sortable: false, value: 'questionType', width: '20%' },
      { text: 'Ações', align: 'center', sortable: false, value: 'actions', width: '15%' },
    ],
    selectedHeaders: [
      { text: 'Título', align: 'center', sortable: false, value: 'title', width: '25%' },
      { text: 'Tipo', align: 'center', sortable: false, value: 'questionType', width: '25%' },
      { text: 'Valor na prova', align: 'center', sortable: false, value: 'weight', width: '25%' },
      { text: 'Ações', align: 'center', sortable: false, value: 'actions', width: '25%' },
    ],
    //tipo de questões: summation, multipleChoice, objective, trueOrFalse, dissertation
    title: '',
    instructions: '',
    selectedQuestions: [],
    questions: [],
    initialDate: '',
    endDate: '',
    editInitialDate: null, //em timestamp
    editEndDate: null, //em timestamp
    selectedClasses: [],
    selectedMonitor: [],
    classes: [],
    monitors: [],
    filterAutoComplete: [
      { name: 'Minhas Perguntas', value: 'myQuestions' },
      { name: 'Todas perguntas públicas do banco', value: 'allQuestions' },
      { name: 'Por área', value: 'byArea' },
    ],
    selectedFilter: 'myQuestions',
    filterAreas: [],
    selectedArea: '',
    areas: [],
    alert: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    itemToDelete: {},
    itemToView: {},
    dialogManageTest: false,
    dialogViewQuestion: false,
    userInfo: {},
    search: '',
    inputSearch: '',
    selectedQuestionsTotalWeight: 0,
    tab: 0,
  }),
  async created() {
    this.userInfo = await this.$getItem('userEHQ')
    await this.getAreas()
    await this.ownQuestions()
    await this.readMonitorByTeacher(this.userInfo.id)
    await this.readClassesByTeacher(this.userInfo.id)

    if (this.manageTest == 'edit') {
      this.title = this.itemToEdit.title
      this.instructions = this.itemToEdit.instructions
      this.selectedQuestions = this.itemToEdit.questions
      this.selectedClasses = this.itemToEdit.class
      this.selectedMonitor = this.itemToEdit.monitors

      //adicionar datas para editar assim
      let end = new Date(this.itemToEdit.endDate)
      this.endDate = end.getTime()
      this.editEndDate = end.getTime()

      let init = new Date(this.itemToEdit.initialDate)
      this.initialDate = init.getTime()
      this.editInitialDate = init.getTime()
    }
  },
  watch: {
    'itemToEdit.id'() {
      this.title = this.itemToEdit.title
      this.instructions = this.itemToEdit.instructions
      this.selectedQuestions = this.itemToEdit.questions
      this.selectedClasses = this.itemToEdit.class
      this.selectedMonitor = this.itemToEdit.monitors

      //adicionar datas para editar assim
      let end = new Date(this.itemToEdit.endDate)
      this.endDate = end.getTime()
      this.editEndDate = end.getTime()

      let init = new Date(this.itemToEdit.initialDate)
      this.initialDate = init.getTime()
      this.editInitialDate = init.getTime()
    },
    async selectedFilter() {
      if (this.selectedFilter == 'myQuestions') await this.ownQuestions()
      if (this.selectedFilter == 'allQuestions') await this.readPublicQuestions()
      if (this.selectedFilter == 'byArea') {
        this.filterAreas = this.areas
      }
    },
    async selectedArea() {
      await this.readQuestionsByArea(this.selectedArea)
    },

    inputSearch() {
      if (!this.inputSearch) {
        this.search = ''
        this.$store.commit('user/UPDATE_LOADING', true)
        setTimeout(() => {
          this.$store.commit('user/UPDATE_LOADING', false)
        }, 100)
      }
    },

    selectedQuestions() {
      this.refreshWeightQuestions()
    },
  },
  methods: {
    // FRONTEND BÁSICO
    showQuestionType(type) {
      //tipo de questões: summation, multipleChoice, objective, trueOrFalse, dissertation
      if (type == 'objective') return 'Multipla Escolha'
      if (type == 'summation') return 'Somatório'
      if (type == 'multipleChoice') return 'Multipla Escolha Multi-Resposta'
      if (type == 'trueOrFalse') return 'Verdadeiro ou Falso'
      if (type == 'dissertation') return 'Dissertativa'
    },
    showDifficultyType(item) {
      if (item == 'easy') return 'Fácil'
      if (item == 'medium') return 'Médio'
      if (item == 'hard') return 'Difícil'
    },

    showNameOfArea(id) {
      for (let i = 0; i < this.areas.length; i++) {
        if (this.areas[i].id == id) return this.areas[i].name
      }
      return 'Category not found'
    },

    showQuestionAlreadySelected(item) {
      let itemIndex = -1
      this.selectedQuestions.forEach((obj, index) => {
        if (obj.id == item.id) itemIndex = index
      })
      if (itemIndex > -1) return true
      else return false
    },

    // questão selecionada
    addQuestion(item) {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        let check = false
        this.selectedQuestions.forEach((obj) => {
          if (obj.id == item.id) check = true
        })
        if (!check) {
          let newQuestion = JSON.parse(JSON.stringify(item))
          newQuestion.weight = '1'
          this.selectedQuestions.push(newQuestion)
        } else {
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Atenção, pergunta <b>já adicionada</b> à lista de selecionadas!',
            icon: 'mdi-alert',
            color: 'test',
          })
        }
        this.$store.commit('user/UPDATE_LOADING', false)
      }, 200)
    },

    handleDeleteQuestion(item) {
      this.alert.status = true
      this.itemToDelete = item
      this.alert.message = `Você gostaria de excluir a pergunta <b>${item.title}</b>?`
    },

    deleteQuestion() {
      let itemIndex = -1
      this.selectedQuestions.forEach((item, index) => {
        if (item.id == this.itemToDelete.id) itemIndex = index
      })
      this.alert.status = false
      this.selectedQuestions.splice(itemIndex, 1)
    },

    handleClose() {
      this.$emit('handleClose')
    },

    handleSearch() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.search = this.inputSearch
        this.$store.commit('user/UPDATE_LOADING', false)
      }, 200)
    },

    handleViewQuestion(item, position) {
      this.itemToView = item
      if (position == 'menuRight' && this.manageTest == 'edit') console.log('faz requisição')
      this.dialogViewQuestion = true
    },

    closeDialogViewQuestion() {
      this.dialogViewQuestion = false
    },

    finish() {
      if (this.manageTest == 'add') {
        this.$emit('addTest', {
          title: this.title,
          instructions: this.instructions,
          class: this.selectedClasses,
          monitors: this.selectedMonitor,
          questions: this.selectedQuestions,
          initialDate: this.initialDate,
          endDate: this.endDate,
        })
        this.resetData()
      } else {
        this.$emit('editTest', {
          id: this.itemToEdit.id,
          title: this.title,
          instructions: this.instructions,
          class: this.selectedClasses,
          monitors: this.selectedMonitor,
          questions: this.selectedQuestions,
          initialDate: this.initialDate,
          endDate: this.endDate,
        })
      }
    },

    refreshWeightQuestions() {
      let sum = 0
      this.selectedQuestions.forEach((item) => {
        sum = Number(item.weight) + Number(sum)
      })
      this.selectedQuestionsTotalWeight = sum
    },

    //chamado por ref no componente pai
    resetData() {
      this.selectedQuestions = []
      this.title = ''
      this.search = ''
      this.inputSearch = ''
      this.instructions = ''
      this.selectedFilter = 'myQuestions'
      this.selectedClasses = []
      this.selectedMonitor = []
      this.initialDate = ''
      this.endDate = ''
      //resetar os dados da data
      this.$store.commit(
        'user/UPDATE_CLEAN_ADVANCED_COLLABORATIVEWORK',
        this.cleanAdvancedCollaborativeWork + 1
      )
      this.goTab0()
    },

    validate($event, item) {
      let itemIndex = -1
      this.selectedQuestions.forEach((obj, index) => {
        if (obj.id == item.id) itemIndex = index
      })
      let keyCode = $event.keyCode ? $event.keyCode : $event.which
      // only allow number and one dot
      if (
        (keyCode < 48 || keyCode > 57) &&
        (keyCode !== 46 || this.selectedQuestions[itemIndex].weight.indexOf('.') !== -1)
      ) {
        // 46 is dot
        $event.preventDefault()
      }
      // restrict to 2 decimal places
      if (
        this.selectedQuestions[itemIndex].weight !== null &&
        this.selectedQuestions[itemIndex].weight.indexOf('.') > -1 &&
        this.selectedQuestions[itemIndex].weight.split('.')[1].length > 1
      ) {
        $event.preventDefault()
      }
    },

    validateMouse(item) {
      let itemIndex = -1
      this.selectedQuestions.forEach((obj, index) => {
        if (!obj.weight) obj.weight = '1'
        if (obj.id == item.id) itemIndex = index
      })
      if (!this.selectedQuestions[itemIndex].weight) this.selectedQuestions[itemIndex].weight = '1'
    },

    goTab0() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.tab = 0
        this.$store.commit('user/UPDATE_LOADING', false)
        this.$emit('goTab0')
      }, 170)
    },

    goTab1() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.tab = 1
        this.$store.commit('user/UPDATE_LOADING', false)
        this.$emit('goTab1')
      }, 170)
    },

    convertDataToTimeStamp(data) {
      if (data.year && data.month && data.day && data.hour && data.minute) {
        let timeStamp = new Date(
          data.year,
          Number(data.month) - 1,
          Number(data.day),
          Number(data.hour),
          Number(data.minute)
        )
        return timeStamp.getTime()
      }
      return ''
    },

    updateTestInitialDate(item) {
      this.initialDate = this.convertDataToTimeStamp(item)
      if (this.initialDate > this.endDate) this.editEndDate = this.initialDate + 60000 * 45
    },

    updateTestEndDate(item) {
      this.endDate = this.convertDataToTimeStamp(item)
      if (this.initialDate > this.endDate) this.editInitialDate = this.endDate - 60000 * 45
    },

    //backend
    async getAreas() {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.getAllAvailableAreas()
        if (req.success) this.areas = req.data
      } catch (e) {
        console.error(e)
      } finally {
      }
    },

    async ownQuestions() {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const user = await this.$getItem('userEHQ')
        let req = await Teacher.readQuestionsByTeacher(user.id)
        if (req.success) {
          req.data.forEach((question) => {
            let areaData = []
            question.area.forEach((area) => {
              areaData.push(area.id)
            })
            question.area = areaData
          })
          this.questions = req.data
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async readPublicQuestions() {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.readPublicQuestions()
        if (req.success) {
          req.data.forEach((question) => {
            let areaData = []
            question.area.forEach((area) => {
              areaData.push(area.id)
            })
            question.area = areaData
          })
          this.questions = req.data
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async readQuestionsByArea(areaId) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Teacher.readQuestionsByArea(areaId)
        if (req.success) {
          req.data.forEach((question) => {
            let areaData = []
            question.area.forEach((area) => {
              areaData.push(area.id)
            })
            question.area = areaData
          })
          this.questions = req.data
        }
      } catch (e) {
        console.error(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async readMonitorByTeacher(teacherId) {
      try {
        let req = await Teacher.readMonitorByTeacher(teacherId)
        if (req.success) {
          req.data.forEach((monitor) => {
            monitor.name = `${monitor.name} ${monitor.surname}`
          })
          this.monitors = req.data
        }
      } catch (e) {
        console.error(e)
      } finally {
      }
    },

    async readClassesByTeacher(teacherId) {
      try {
        let req = await Teacher.readClassesByTeacher(teacherId)
        if (req.success) {
          this.classes = req.data.classes
        }
      } catch (e) {
        console.error(e)
      } finally {
      }
    },
  },
}
</script>

<style>
.viewQuestionStyle:hover {
  font-weight: 600;
  cursor: pointer;
}
</style>
